package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.LineCap;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.apexcharts.series.data.Goals;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColumnWithMarkers extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		
		chartOptions.getPlotOptions().getBar().setColumnWidth("60%");
		chartOptions.setColors(Arrays.asList(new Color("#00E396")));	
		chartOptions.getDataLabels().setEnabled(false);

		chartOptions.getLegend().setShow(true).setShowForSingleSeries(true)
			.setCustomLegendItems(Arrays.asList("Actual", "Expected"))
			.getMarkers().setFillColors(Arrays.asList(new Color("#00E396"), new Color("#775DD0")));

		Series series = new Series();
		series.setName("Actual");
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("2011").setY(1292)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(1400).setStrokeHeight(5).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2012").setY(4432)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(5400).setStrokeHeight(5).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2013").setY(5423)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(5200).setStrokeHeight(5).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2014").setY(6653)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(6500).setStrokeHeight(5).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2015").setY(8133)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(6600).setStrokeHeight(13).setStrokeWidth(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2016").setY(7132)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(7500).setStrokeHeight(5).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2017").setY(7332)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(8700).setStrokeHeight(5).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2018").setY(6553)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(7300).setStrokeHeight(2).setStrokeDashArray(2).setStrokeColor(new Color("#775DD0"))))
				));

		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}