package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class GroupedStackedColumns extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR).setStacked(true);
		chartOptions.getStroke().setWidth(1).setColors(Arrays.asList(new Color("#fff")));
		
		chartOptions.getDataLabels().setFormatter(new Function("return val / 1000 + 'K'", "val"));
		chartOptions.getPlotOptions().getBar().setHorizontal(false);
		
		chartOptions.getXaxis().setCategoriesAsArrayString(Arrays.asList(
				"Online advertising",
	            "Sales Training",
	            "Print advertising",
	            "Catalogs",
	            "Meetings",
	            "Public relations"));
		
		chartOptions.getFill().setOpacity(1);
		chartOptions.setColors(Arrays.asList(new Color("#80c7fd"), new Color("#008FFB"), new Color("#80f1cb"), new Color("#00E396")));

		chartOptions.getYaxisSingle().getLabels().setFormatter(new Function("return val / 1000 + 'K'", "val"));
		chartOptions.getLegend().setPosition(LegendPosition.TOP).setHorizontalAlign(HorizontalAlign.LEFT);
		
		Series series = new Series();
		series.setName("Q1 Budget").setGroup("budget");
		series.setDataAsArrayNumber(Arrays.asList(44000, 55000, 41000, 67000, 22000, 43000));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Q1 Actual").setGroup("actual");
		series.setDataAsArrayNumber(Arrays.asList(48000, 50000, 40000, 65000, 25000, 40000));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Q2 Budget").setGroup("budget");
		series.setDataAsArrayNumber(Arrays.asList(13000, 36000, 20000, 8000, 13000, 27000));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Q2 Actual").setGroup("actual");
		series.setDataAsArrayNumber(Arrays.asList(20000, 40000, 25000, 10000, 12000, 28000));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}