package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class NegativeValuesWithColor extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.LINE).getZoom().setEnabled(false);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getTitle().setText("Negative color for values less than 0").setAlign((HorizontalAlign.LEFT));
		
		chartOptions.getStroke().setWidth(5).setCurve(Curve.MONOTONECUBIC);
		
		chartOptions.getPlotOptions().getLine().getColors().setThreshold(0)
			.setColorAboveThreshold(new Color("#0088ee")).setColorBelowThreshold(new Color("#ff0000"));
		
		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep",  "Oct", "Nov", "Dec"));
		
		Series series = new Series();
		series.setDataAsArrayNumber(Arrays.asList(-33, -13, -45, 95, 12, 15, -34, -61, 66, 82, 1, -36));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}