package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartAxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.MarkerShape;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ScatterDateTime extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.SCATTER)
			.getZoom().setType(ChartAxisType.XY);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.setColors(Arrays.asList(new Color("#FF5733"), new Color("#33FF57"), new Color("#3357FF"), new Color("#FF33A1"), 
											 new Color("#33FFF6"), new Color("#1E90FF"), new Color("#FFFF33"), new Color("#A133FF"), 
											 new Color("#FF9933"), new Color("#FF3388")));

		chartOptions.getGrid().getXaxis().getLines().setShow(true);
		chartOptions.getGrid().getYaxis().getLines().setShow(true);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);

		chartOptions.getMarkers().setShape(Arrays.asList(MarkerShape.DIAMOND, MarkerShape.TRIANGLE, MarkerShape.CROSS, 
														 MarkerShape.PLUS, MarkerShape.SQUARE, MarkerShape.LINE,
														 MarkerShape.CIRCLE, MarkerShape.STAR, MarkerShape.SPARKLE))
								 .setSize(10).setFillOpacity(0.8).setStrokeColors(new Color("#333"))
								 .setStrokeWidth(Arrays.asList(1, 1, 3, 3, 1, 4, 1, 1, 1));
		
		chartOptions.getSeries().add(new Series()
			.setName("DIAMOND").setDataAsArrayPairs(getData(new Date("01 Feb 2017 GMT").getTime(), 10, 5, 60)));
		chartOptions.getSeries().add(new Series()
			.setName("TRIANGLE").setDataAsArrayPairs(getData(new Date("11 Feb 2017 GMT").getTime(), 10, 54, 90)));
		chartOptions.getSeries().add(new Series()
			.setName("CROSS").setDataAsArrayPairs(getData(new Date("20 Feb 2017 GMT").getTime(), 8, 10, 50)));
		chartOptions.getSeries().add(new Series()
			.setName("PLUS").setDataAsArrayPairs(getData(new Date("28 Feb 2017 GMT").getTime(), 16, 30, 99)));
		chartOptions.getSeries().add(new Series()
			.setName("SQUARE").setDataAsArrayPairs(getData(new Date("20 Mar 2017 GMT").getTime(), 10, 0, 59)));
		chartOptions.getSeries().add(new Series()
				.setName("LINE").setDataAsArrayPairs(getData(new Date("29 Mar 2017 GMT").getTime(), 10, 0, 90)));
		chartOptions.getSeries().add(new Series()
				.setName("CIRCLE").setDataAsArrayPairs(getData(new Date("10 Apr 2017 GMT").getTime(), 10, 5, 35)));
		chartOptions.getSeries().add(new Series()
				.setName("STAR").setDataAsArrayPairs(getData(new Date("20 Apr 2017 GMT").getTime(), 10, 15, 60)));
		chartOptions.getSeries().add(new Series()
				.setName("SPARKLE").setDataAsArrayPairs(getData(new Date("29 Apr 2017 GMT").getTime(), 10, 45, 99)));

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private List<Pair> getData(long baseval, int count, int min, int max) {
		List<Pair> data = new ArrayList<Pair>();
		
		for (int i = 0; i < count; i++) {
			data.add(new Pair(baseval, Math.floor(Math.random() * (max - min + 1)) + min));
			
			baseval += 86400000;
		}
		
		return data;
	}
	
}
