package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.LineCap;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.apexcharts.series.data.Goals;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BarWithMarkers extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		
		chartOptions.getPlotOptions().getBar().setHorizontal(true);
		chartOptions.setColors(Arrays.asList(new Color("#00E396")));
		
		chartOptions.getDataLabels().setFormatter(
				new Function("const goals = opt.w.config.series[opt.seriesIndex].data[opt.dataPointIndex].goals\r\n"
				+ "if (goals && goals.length) {\r\n"
				+ "    return `${val} / ${goals[0].value}`\r\n"
				+ "}\r\n"
				+ "return val", "val", "opt"));
		
		chartOptions.getLegend().setShow(true).setShowForSingleSeries(true)
			.setCustomLegendItems(Arrays.asList("Actual", "Expected"))
			.getMarkers().setFillColors(Arrays.asList(new Color("#00E396"), new Color("#775DD0")));

		Series series = new Series();
		series.setName("Actual");
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("2011").setY(12)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(14).setStrokeWidth(2).setStrokeDashArray(2).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2012").setY(44)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(54).setStrokeWidth(5).setStrokeHeight(10).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2013").setY(54)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(52).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2014").setY(66)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(61).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2015").setY(81)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(66).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#775DD0")))),
			new Data().setX("2016").setY(67)
				.setGoals(Arrays.asList(new Goals().setName("Expected").setValue(70).setStrokeWidth(5).setStrokeHeight(10).setStrokeColor(new Color("#775DD0"))))
				));

		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}