package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LineCap;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.apexcharts.series.data.Goals;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class HorizontalBoxPlot extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BOXPLOT);
		chartOptions.getTitle().setText("Horizontal BoxPlot with Outliers").setAlign(HorizontalAlign.LEFT);

		chartOptions.getPlotOptions()
			.getBar().setHorizontal(true).setBarHeight("40%");
		chartOptions.getPlotOptions()
			.getBoxPlot().getColors().setUpper(new Color("#B6C454")).setLower(new Color("#EDBFB7"));

		chartOptions.getStroke().setColors(Arrays.asList(new Color("#333")));
		
		Series series = new Series();
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("Category A").setY(Arrays.asList(54, 66, 69, 75, 88))
				.setGoals(Arrays.asList(
					new Goals().setValue(90).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#F283B6")),
					new Goals().setValue(93).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#F283B6"))
				)),
			new Data().setX("Category B").setY(Arrays.asList(43, 65, 69, 76, 81)),
			new Data().setX("Category C").setY(Arrays.asList(31, 39, 45, 51, 59)),
			new Data().setX("Category D").setY(Arrays.asList(39, 46, 55, 65, 71))
				.setGoals(Arrays.asList(
					new Goals().setValue(30).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#F283B6")),
					new Goals().setValue(32).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#F283B6")),
					new Goals().setValue(76).setStrokeWidth(10).setStrokeHeight(0).setStrokeLineCap(LineCap.ROUND).setStrokeColor(new Color("#F283B6"))
				)),
			new Data().setX("Category E").setY(Arrays.asList(29, 31, 35, 39, 44))
			));
		
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}