package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisPosition;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MultiGroupSlope extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		        
		chartOptions.getChart().setHeight("100%").setType(ChartType.LINE);
		chartOptions.getPlotOptions().getLine().setIsSlopeChart(true);
		
		chartOptions.getTooltip().setFollowCursor(true).setIntersect(false).setShared(true);
		
		chartOptions.getDataLabels().getBackground().setEnabled(true);
		chartOptions.getDataLabels().setFormatter(new Function("const seriesName = opts.w.config.series[opts.seriesIndex].name; return val !== null ? seriesName : '';", "val", "opts"));

		chartOptions.getYaxisSingle().setShow(true).getLabels().setShow(true);
		chartOptions.getXaxis().setPosition(AxisPosition.BOTTOM);
		
		chartOptions.getLegend().setShow(true).setPosition(LegendPosition.TOP).setHorizontalAlign(HorizontalAlign.LEFT);

		chartOptions.getStroke().setWidth(Arrays.asList(2, 3, 4, 2)).setDashArray(Arrays.asList(0, 0, 5, 2)).setCurve(Curve.SMOOTH);
		
		Series series = new Series();
		series.setName("Blue");
		series.setDataAsArrayObject(Arrays.asList(new Data().setX("Category 1").setY(503), 
												  new Data().setX("Category 2").setY(580),
												  new Data().setX("Category 3").setY(135)));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Green");
		series.setDataAsArrayObject(Arrays.asList(new Data().setX("Category 1").setY(733), 
												  new Data().setX("Category 2").setY(385),
												  new Data().setX("Category 3").setY(715)));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Orange");
		series.setDataAsArrayObject(Arrays.asList(new Data().setX("Category 1").setY(255), 
												  new Data().setX("Category 2").setY(211),
												  new Data().setX("Category 3").setY(441)));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Red");
		series.setDataAsArrayObject(Arrays.asList(new Data().setX("Category 1").setY(428), 
												  new Data().setX("Category 2").setY(749),
												  new Data().setX("Category 3").setY(559)));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}