package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class NegativeArea extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();

		chartOptions.getChart().setHeight("100%").setType(ChartType.AREA).getZoom().setEnabled(false);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getTitle().setText("Negative color for values less than 0").setAlign((HorizontalAlign.LEFT));
		
		chartOptions.getStroke().setWidth(0);
		
		chartOptions.getPlotOptions().getLine().getColors().setThreshold(0)
			.setColorAboveThreshold(new Color("#0088ee")).setColorBelowThreshold(new Color("#ff0000"));
		
		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep",  "Oct", "Nov", "Dec"));
		
		Series series = new Series();
		series.setDataAsArrayNumber(Arrays.asList(0, -41, 35, -51, 0, 62, -69, 32, -32, 54, 16, -50));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}