package com.webonlineapp.hyjavachartsdemo12.components;

import com.vaadin.flow.component.Component;
import com.vaadin.flow.component.HasComponents;
import com.vaadin.flow.component.HasSize;
import com.vaadin.flow.component.Tag;
import com.vaadin.flow.component.UI;
import com.vaadin.flow.component.dependency.JavaScript;
import com.vaadin.flow.component.page.Page;
import com.webonlineapp.hyjavachartsdemo12.Properties;

@Tag("div")

@JavaScript(value=Properties.HIGHCHARTS_VERSION + "highcharts.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "highcharts-more.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "highcharts-3d.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/networkgraph.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/drilldown.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/funnel.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/heatmap.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/exporting.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/solid-gauge.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/sankey.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/wordcloud.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/histogram-bellcurve.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/treemap.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/bullet.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/tilemap.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/pareto.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/boost.js")
//@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/datagrouping.js")	// this one causes tooltip date issues
@JavaScript("https://www.hyjavacharts.com/content/js/datagrouping.js")			// hack fix
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/windbarb.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/xrange.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/variwide.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/annotations.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/variable-pie.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/vector.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/sunburst.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/data.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/pattern-fill.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/parallel-coordinates.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/venn.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/cylinder.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/funnel3d.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/pyramid3d.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/dependency-wheel.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/item-series.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/timeline.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/organization.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/dumbbell.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/lollipop.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/arc-diagram.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/series-label.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/sonification.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/pictorial.js")
@JavaScript(value=Properties.HIGHCHARTS_VERSION + "modules/treegraph.js")
@JavaScript("https://www.hyjavacharts.com/content/js/highcharts-regression.js")

public class HighchartComponent extends Component implements HasComponents, HasSize {
	private static final long serialVersionUID = 1L;
	
	private static long chartId = 1;
	
	
	/**
	 * 
	 */
	public HighchartComponent() { 
        setId("highchart_" + getNextChartId());
 	}
	
	/**
	 * 
	 * @param chartOptions
	 */
	public void displayChart(String chartOptions) {
		displayChart("", chartOptions, "", "");
	}
	
	/**
	 * 
	 * @param globalOptions
	 * @param chartOptions
	 */
	public void displayChart(String globalOptions, String chartOptions, String demoJavaScriptPre, String demoJavaScriptPost) {
		Page page = UI.getCurrent().getPage();
		
		page.executeJs("if (typeof intervalId !== 'undefined') { clearInterval(intervalId); }");
		
		if (globalOptions != null && !globalOptions.equals("")) {
			String globalOptionsJs = "Highcharts.setOptions(" + globalOptions + ");";
			page.executeJs(globalOptionsJs);
		}

    	//String chartOptionsJs = "var chart = Highcharts.chart('" + getId().get() + "', " + chartOptions + ");";
    	String chartOptionsJs = "chart = Highcharts.chart('" + getId().get() + "', " + chartOptions + ");";

    	page.executeJs(demoJavaScriptPre + chartOptionsJs + demoJavaScriptPost);
	}
	
	/**
	 * 
	 * @return
	 */
	private long getNextChartId() {
		chartId++;
		
		if (chartId > 10000) {
			chartId = 1;
		}
		
		return chartId;
	}
	
	/**
	 * 
	 */
	public void play() {
		UI.getCurrent().getPage().executeJs("chart.toggleSonify();");
	}
	
}
