package com.webonlineapp.hyjavachartsdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.common.LinearGradient;
import com.hyjavacharts.model.common.Stop;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.ZoomType;
import com.hyjavacharts.model.highcharts.series.SeriesArearange;
import com.webonlineapp.hyjavachartsdemo12.chartdata.AreaRangeData;
import com.webonlineapp.hyjavachartsdemo12.charts.DemoChartBase;

public class AreaRange extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.AREARANGE)
			.getZooming().setType(ZoomType.X);
        chartOptions.getChart().getScrollablePlotArea().setMinWidth(600).setScrollPositionX(1);
		
		chartOptions.getTitle().setText("Temperature variation by day").setAlign(HorizontalAlign.LEFT);
		chartOptions.getSubtitle().setText("Source: <a href=\"https://veret.gfi.uib.no/\" target=\"_blank\">Universitetet i Bergen</a>").setAlign(HorizontalAlign.LEFT);
        
		chartOptions.getXAxisSingle().setType(AxisType.DATETIME).getAccessibility().setRangeDescription("Range: Jan 1st 2023 to Jan 1st 2024.");
		chartOptions.getYAxisSingle().getTitle().setText(null);

		chartOptions.getTooltip().setCrosshairs(true).setShared(true).setValueSuffix("°C").setXDateFormat("%A, %b %e");
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getData().setCsv(new AreaRangeData().get());
		
		SeriesArearange seriesArearange = new SeriesArearange();
		seriesArearange.setName("Temperatures");
		seriesArearange.setColor(new Color(new LinearGradient(0, 0, 0, 1), 
											Arrays.asList(new Stop(0, new Color("#ff0000")), new Stop(1, new Color("#0000ff")))));
		
		seriesArearange.getLabel().setEnabled(false);
		chartOptions.getSeries().add(seriesArearange);
		
		return highChart;
	}

}
