package com.webonlineapp.hyjavachartsdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo12.charts.DemoChartBase;

public class WithDataLabels extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
	    
		chartOptions.getChart().setType(ChartType.LINE);
		chartOptions.getTitle().setText("Monthly Average Temperature");
		chartOptions.getSubtitle().setText("Source: <a href=\"https://en.wikipedia.org/wiki/List_of_cities_by_average_temperature\" target=\"_blank\">Wikipedia.com</a>");
	
		XAxis xAxis = new XAxis();
		xAxis.setCategories(Arrays.asList("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"));
		chartOptions.getXAxis().add(xAxis);
		
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Temperature (°C)");
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getPlotOptions().getLine().setEnableMouseTracking(false).getDataLabels().setEnabled(true);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.getLabel().setEnabled(false);
		seriesLine.setName("Reggane");
		seriesLine.setDataAsArrayNumber(Arrays.asList(16.0, 18.2, 23.1, 27.9, 32.2, 36.4, 39.8, 38.4, 35.5, 29.2, 22.0, 17.8));
		chartOptions.getSeries().add(seriesLine);
		
		seriesLine = new SeriesLine();
		seriesLine.getLabel().setEnabled(false);
		seriesLine.setName("Tallinn");
		seriesLine.setDataAsArrayNumber(Arrays.asList(-2.9, -3.6, -0.6, 4.8, 10.2, 14.5, 17.6, 16.5, 12.0, 6.5, 2.0, -0.9));
		chartOptions.getSeries().add(seriesLine);
		
		return highChart;
	}

}
