package com.webonlineapp.hyjavachartsdemo12.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.Stacking;
import com.hyjavacharts.model.highcharts.series.SeriesArea;
import com.webonlineapp.hyjavachartsdemo12.charts.DemoChartBase;

public class StackedArea extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.AREA);
		chartOptions.getTitle().setText("Greenhouse gases from Norwegian economic activity");
		chartOptions.getSubtitle().setText("Source: <a href=\"https://www.ssb.no/en/statbank/table/09288/\" target=\"_blank\">SSB</a>");

		YAxis yAxi = new YAxis();
		yAxi.getTitle().setUseHTML(true).setText("Million tonnes CO<sub>2</sub>-equivalents");
		chartOptions.getYAxis().add(yAxi);

		chartOptions.getTooltip().setShared(true).setHeaderFormat("<span style=\"font-size:12px\"><b>{point.key}</b></span><br>");
		
		chartOptions.getPlotOptions().getArea()
			.setPointStart(2012)
			.setStacking(Stacking.NORMAL)
			.setLineColor(new Color("#666666"))
			.setLineWidth(1)
			.getMarker()
				.setLineWidth(1)
				.setLineColor(new Color("#666666"));
		
		SeriesArea seriesArea = new SeriesArea();
		seriesArea.getLabel().setEnabled(false);
		seriesArea.setName("Ocean transport");
		seriesArea.setDataAsArrayNumber(Arrays.asList(13234, 12729, 11533, 17798, 10398, 12811,
	            										15483, 16196, 15060, 13365, 13301));
		chartOptions.getSeries().add(seriesArea);
		
		seriesArea = new SeriesArea();
		seriesArea.getLabel().setEnabled(false);
		seriesArea.setName("Households");
		seriesArea.setDataAsArrayNumber(Arrays.asList(6686, 6536, 6389, 6384, 6251, 5719,
	            										5611, 5040, 5079, 5088, 4988));
		chartOptions.getSeries().add(seriesArea);
		
		seriesArea = new SeriesArea();
		seriesArea.getLabel().setEnabled(false);
		seriesArea.setName("Agriculture and hunting");
		seriesArea.setDataAsArrayNumber(Arrays.asList(4812, 4872, 4961, 5001, 5070, 5035,
	            										5045, 5004, 5015, 5076, 4935));
		chartOptions.getSeries().add(seriesArea);
		
		seriesArea = new SeriesArea();
		seriesArea.getLabel().setEnabled(false);
		seriesArea.setName("Air transport");
		seriesArea.setDataAsArrayNumber(Arrays.asList(3502, 3844, 4139, 4351, 3802, 4020,
	            										4461, 5074, 1558, 1247, 2694));
		chartOptions.getSeries().add(seriesArea);
		
		seriesArea = new SeriesArea();
		seriesArea.getLabel().setEnabled(false);
		seriesArea.setName("Construction");
		seriesArea.setDataAsArrayNumber(Arrays.asList(2019, 2189, 2150, 2217, 2179, 2258,
	            										2348, 2196, 2018, 2180, 2127));
		chartOptions.getSeries().add(seriesArea);
		
		return highChart;
	}
	
}
