package com.webonlineapp.hyjavastockdemo11.util;

import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.time.Duration;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.ZonedDateTime;

public class DateUtil {
	
	/**
	 * 
	 * @param year
	 * @param month
	 * @param day
	 * @return
	 */
	public static long toMilli(int year, int month, int day) {
		return ZonedDateTime.of(year, month, day, 0, 0, 0, 0, ZoneId.of("UTC")).toInstant().toEpochMilli();
	}
	
	/**
	 * 
	 * @param year
	 * @param month
	 * @param day
	 * @param hour
	 * @return
	 */
	public static long toMilli(int year, int month, int day, int hour) {
		return ZonedDateTime.of(year, month, day, hour, 0, 0, 0, ZoneId.of("UTC")).toInstant().toEpochMilli();
	}
	
	/**
	 * 
	 * @param started
	 * @param ended
	 * @return
	 */
	public static String formatDuration(LocalDateTime started, LocalDateTime ended) {
		DecimalFormat df = new DecimalFormat("#####");
		df.setRoundingMode(RoundingMode.HALF_UP);
		df.setMinimumFractionDigits(0);
		
		double diff = Duration.between(started, ended).toMillis();
		if (diff < 1) {
			diff = 1;
		}
		
		return df.format(diff);
	}

}
